<?php
require "settei.php"; //設定ファイルの挿入
//POSTされた
if (isset($_GET["type"])) {
  $time_start = microtime(true);
  $type = $_GET["type"];
  $words = $_GET["words"];
  if (isset($_GET["page"])) {
    $page = $_GET["page"];
  } else {
    $page = "0";
  }
  switch ($type) {
    case "0":  //パソコン用
      $max = COUNT0;
      $tmpname = TMPFILE0;
      $storydir = PCDIR;
      $chrcode = WEBCODE;
      break;
    case "1":  //携帯用
      $max = COUNT1;
      $tmpname = TMPFILE1;
      $storydir = MOBILE;
      $chrcode = MOBCODE;
      break;
  }
  $outpage = file_get_contents($tmpname);  //テンプレートファイル読み込み
  $outpage = mb_convert_encoding($outpage, PHPCODE , $chrcode);
  $outpage = str_replace("type=\"text\"","type=\"text\" value=\"".$words."\"",$outpage);
  
  $search_word =word_make($words,$word_tbl);
  $count = count_search($search_word);

  $page_suu = floor($count / $max);
  if ($count % $max !=0) $page_suu++;
  $footer = "";
  if ($page_suu <=1) {
    if ($count == "0") {
      $match = $words."は見つかりませんでした。<br>";
    } else {
    $match = put_find($search_word,$page * $max,$max,$word_tbl,$storydir);
    }
  } else {
    $match = put_find($search_word,$page * $max,$max,$word_tbl,$storydir);
    $words = mb_convert_encoding($words,URLCODE,PHPCODE);
    $words = urlencode($words);
    $footer = "<Div Align=\"center\">";
    if ($page > 0) {
      $footer .= "<a href=\"".MAIN_NAME."?type=$type&page=0&words=$words\">&lt;&lt;</a>";
      $footer .= " <a href=\"".MAIN_NAME."?type=$type&page=".($page -1)."&words=$words\">&lt;</a>";
    }
    $foot_start = $page -4;
    if ($foot_start < 0) $foot_start = 0;
    $foot_end = $foot_start + 9;
    if ($foot_end > $page_suu-1) $foot_end = $page_suu -1;
    $foot_start = $foot_end - 9;
    if ($foot_start < 0) $foot_start =0;
    for ($i=$foot_start;$i<=$foot_end;$i++) {
      if ($i == $page) {
        $footer .= " <b>".($i+1)."</b>";
      } else {
        $footer .= " <a href=\"".MAIN_NAME."?type=$type&page=$i&words=$words\">".($i+1)."</a>";
      }
    }
    if ($page < $page_suu-1) {
      $footer .= " <a href=\"".MAIN_NAME."?type=$type&page=".($page + 1)."&words=$words\">&gt;</a>";
      $footer .= " <a href=\"".MAIN_NAME."?type=$type&page=".($page_suu-1)."&words=$words\">&gt;&gt;</a>";
    }
    $footer .= "</Div>";
  }
  $time = microtime(true) - $time_start;
  $time = sprintf("%.2f",$time);
  $header = "$count 件 ($time 秒)<br><br>";
  $outpage = str_replace("内容表示",$header . $match . $footer,$outpage);
  $disp_enc = WEBCODE;
  echo $outpage;
}

function word_make($words ,&$tbl) {
  $length = "0";
  $words = str_replace("　"," ",$words);   //全角スペースを半角に
  $words = trim($words);  //前後の空白を消去
  $word = explode(" ",$words);  //空白で分割
  $str_find ="";
  foreach($word as $strtmp) {
    $strtmp = trim($strtmp);
    if ($strtmp == "") continue;
    $str_option = strtoupper($strtmp);
    switch($str_option) {
      case "AND":
        break;
      case "-":
      case "NOT":
        $str_find .= " NOT ";
        break;
      case "+":
      case "OR":
        $length = mb_strlen($str_find);
        if (mb_substr($str_find,$length - 5,5) == " AND ") {
          $str_find = mb_substr($str_find,0,$length - 5);
        }
        $str_find .= " OR ";
        break;
      case "(":
        $str_find .= " " . $str_option . " ";
        break;
      case ")":
        $length = mb_strlen($str_find);
        if (mb_substr($str_find,$length - 5,5) == " AND ") {
          $str_find = mb_substr($str_find,0,$length - 5);
        }
        $str_find .= " " . $str_option . " AND ";
        break;
      default:
        check_word($strtmp,$tbl);
        $str_find .= "( story LIKE '%" .replace_word($strtmp). "%' ";
        $strtmp = mb_convert_kana($strtmp,"AKVC"); //全角片仮名に
        if (check_word($strtmp,$tbl)) {$str_find .="OR story LIKE '%".replace_word($strtmp)."%' ";}
        $strtmp = mb_convert_kana($strtmp,"c");   //全角平仮名に
        if (check_word($strtmp,$tbl)) {$str_find .="OR story LIKE '%".replace_word($strtmp)."%' ";}
        $strtmp = mb_convert_kana($strtmp,"ah");   //半角片仮名に
        if (check_word($strtmp,$tbl)) {$str_find .="OR story LIKE '%".replace_word($strtmp)."%' ";}
        $str_find .= ") AND ";
    }
  }
  $length = mb_strlen($str_find);
  if (mb_substr($str_find,$length - 5,5) == " AND ") {
    $str_find = mb_substr($str_find,0,$length - 5);
  }
  return $str_find;
}

function replace_html($word) {
  $words = $word;
  $words = str_replace("&","&amp;",$words); //&を変換
  $words = str_replace("<","&lt",$words);  //不等号を変換
  $words = str_replace(">","&gt;",$words); //不等号を変換
  return $words;
}
function replace_word($word) {
  $words = $word;
  $words = replace_html($words);
  $words = str_replace("\\","\\\\",$words); 
  $words = str_replace("%","\%",$words);   //mysql用に変換
  $words = str_replace("_","\_",$words);
  $words = str_replace("'","\\'",$words);
  return $words;
}

function check_word($word,&$table) {
  $ret = true;
  if (count($table) !=0) {
    foreach($table as $strtmp) {
      if ($word == $strtmp) {
        $ret = false;
        break;
      }
    }
  }
  if ($ret) {$table[] = $word;}
  return $ret;
}

function count_search($words) {
  $index_res = mysql_query("SELECT count(*) FROM ".TABLENAME." WHERE $words");
  if ($index_res != false) {
    $count = mysql_result($index_res,0); //ヒット数
  } else {
    $count = 0;
  }
return $count;
}

function put_find($words,$ofs,$kazu,&$tbl,$storydir) {
  $cnt = "0";
  $index_res = mysql_query("SELECT id,title,url,story FROM " . TABLENAME . " WHERE 
  $words ORDER BY id LIMIT $ofs , $kazu");
  if (!$index_res) {
    $find_str = "データベースに異常が発生しました。<br>";
  } else {
    $find_str = "";
    while($index_tbl = mysql_fetch_array($index_res)) {
      $find_str .= "<a href=\"" . $storydir;
      $find_str .= $index_tbl["url"] ."\">" . highlight($index_tbl["title"],$tbl) . "</a><br>";
      $strtmp = preg_replace("/<[^<>]+?>/s","",$index_tbl["story"]);
      $strtmp = string_cut($strtmp,$tbl);
      $find_str .= highlight($strtmp,$tbl); //タイトル消去して追加
      $find_str .= "<br><br>";
    }
  }
  return $find_str;
}

function highlight($match ,&$word_tbl) {
  foreach($word_tbl as $strtmp) {
    $strtmp = replace_html($strtmp);
    $match = str_replace($strtmp,"<font color=\"#FF0000\"><b>".$strtmp."</b></font>",$match);
  }
  return $match;
}

function string_cut($str,&$word_tbl) {
//全角120文字前後
  $length = mb_strlen($str);
  if ($length <= 150) return $str;
  $mini = $length;
  foreach($word_tbl as $strtmp) {
    $hit_pos = mb_stripos($str,$strtmp);
    if ($hit_pos == false) continue;
    if ($hit_pos < $mini) $mini = $hit_pos;
  }
  if(($mini - 20) < 0) {
    $str = mb_substr($str,0,150) . "…";
  } else {
    $mini -= 20;
    $pos = $mini + 150;
    if ($pos > $length) {
      $pos = $length - 150;
      $foot = "";
    } else {
      $pos = $mini;
      $foot = "…";
    }
  $str = "…" . mb_substr($str,$pos,150) . $foot;
  }
  return $str;
}
?>